#Automatix2 written and maintained by James Sanders (jimmyjazz14@gmail.com)


## RESIN 3.2.2 ################################################################
#created by James Sanders
#http://www.jamessanders.info/resin
#please send bug reports on this file to James Sanders (jimmyjazz14@gmail.com)
#build date: Fri, 27 Jul 2007 21:03:18 +0000
###########################################################################


#modifications to this file should be send to jimmyjazz14@gmail.com
#Thu Sep 28 17:04:32 2006
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
from resin_config import *
import operator
class script:
	def __init__(self):
		self.id = ""
		self.title = ""
		self.description = ""
		self.exe = ""
	def __cmp__(self, other):
		return cmp(self.title, other.title)
	def __str__(self):
		return str(self.title)
class script_list:
	def __init__(self):
		self.type = ""
		self.icon = ""
		self.scripts = []
		self.scripts_uninstall = []
	def seperate_scripts(self):
		tmp = []
		for script in self.scripts:
			if script.id not in axUser.get_installed():
				tmp += [script]
			else:
				self.scripts_uninstall += [script]
		self.scripts = tmp
		self.scripts.sort(key=operator.attrgetter('title'))
		self.scripts_uninstall.sort(key=operator.attrgetter('title'))
	def generate_model(self,state):
		if state == 0:
			selected = self.scripts
			note = ""			
		else:
			selected = self.scripts_uninstall
			note = "<i>(Installed Check to uninstall)</i>"
		self.model = gtk.ListStore(
					gobject.TYPE_BOOLEAN,
					gobject.TYPE_STRING,
					gobject.TYPE_BOOLEAN,
					gobject.TYPE_STRING,
					gobject.TYPE_STRING
					);
		selected.sort()
		for script in selected:
			note = "";
			if script.restricted == "True":
				if conf.restricted:
					rest_color = None
				else:
					rest_color = "grey"
					note+="<i> (Restricted) </i>"
			else:
				if (script.not_strict):
					rest_color = "blue"
					note+="<i> (%s) </i>"%script.desktop
				else:
					rest_color = None
			if script.id in conf.selected_scripts:
				check = True
			else:
				check = False
			desc = "<b>%s</b>\n%s %s"%(script.title,script.description,note)
			new = self.model.append()
			self.model.set(new,
					0,check,
					1,desc,
					2,1,
					3,script.id,
					4,rest_color
					)
		return self.model
